
// 버튼 추가 함수
function addButton(host, img, x, y, width, height, offsets, onclick) {
    var btn = new Button;
    btn.resize(x, y, width, height);
    var imgset = new PieceSet(img);
    btn.drawable = imgset;
    btn.onclick = onclick;

    btn.resetImages = function () {
        var count = offsets.length / 2;
        for (var i = 0; i < count; i++) {
            var ox = offsets[i * 2];
            var oy = offsets[i * 2 + 1];
            if (ox == -1) {
                imgset.setPieceRect(i, 0, 0, 0, 0);
                continue;
            }
            imgset.setPieceRect(i, ox, oy, width, height);
        }
    };
    btn.resetImages();
    host.attach(btn);
    return btn;
};


var ITEM_WIDTH = 448;
var ITEM_HEIGHT = 40;
var itemMatrix = new Matrix;

// 이미지 리소스
res.fg = new Image("training1.png");
res.sheet1 = new Texture("training2.png");
res.sheet2 = new Texture("arcade.png");
res.cursor = new Piece("mouseCursor.bmp", 0, 0, 32, 32);
res.scrollBar = new DrawScrollBar;

function MapList() {


    //스크롤바를 만들자

    var scroll = new ScrollBar();
    var list = new Component; // new ListBox;
    var maxX = 0;
    var maxY = 0;
    var selected = 0;
    var rName = 0;
    var rMax = 0;
    var stage = 0;
    var index = 0;
    var modelview = new Component();
    modelview.resize(565, 150, 128, 128);
    var info = new Array(200);
    info[0] = " ";

    list.resize(60, 100, ITEM_WIDTH * 2 + 10, ITEM_HEIGHT * 13);
    list.scroll = scroll;

    scroll.resize(475, 100, 21, 530);
    scroll.itemHeight = ITEM_HEIGHT;
    scroll.barDrawable = res.scrollBar;

    // 전경, 리스트보다 앞에 있다.
    var fg = new Component;
    fg.resize(0, 0, 1024, 768);
    fg.drawable = res.fg;

    this.remove = function () {
        fg.remove();
    }

    this.addList = function(name, text, modelno, map, roomName, roomMax) {
        index++;


        var myIndex = index;
        var myrName = roomName;
        var myrMax = roomMax;
        var button = addButton(scene, res.sheet1, 225, maxY, 190, ITEM_HEIGHT, [0, 400, 0, 400, 0, 400], function () {
            selected = myIndex;
            rName = myrName;
            rMax = myrMax;
            stage = map;

            var model = new ModelImage(modelno);
            model.camera.fovY = 0.5;
            model.camera.far = 1000;
            switch ((modelno / 1000) | 0) {
                case 3: // 무기 부품
                    model.camera.target.y -= 1;
                    break;
                case 1: // 다리 부품
                case 2: // 몸통 부품
                    model.camera.target.y -= 0.5;
                    break;
                case 6: // 악세사리
                    model.camera.target.y -= 0.15;
                    break;
                case 8:
                    model.camera.far = 100;
                    model.camera.target.y += 1;
                    model.camera.position.z -= 20;
                    break;
                default:
                    //  alert(modelno);
            }
            model.matrix = itemMatrix;
            modelview.drawable = model;

        });

        button.ondraw = function () {

            if (myIndex == selected) {
                ctx.color = 0xffffff00;
            }
            else {
                ctx.color = 0xffffffff;
            }
            ctx.fillText(name, 10, 25);
            if (myIndex == selected) {
                ctx.color = 0xffffffff; // 원상복구
            }
        };

        info[index] = text;

        list.attach(button);

        maxY = maxY + ITEM_HEIGHT;
        scroll.range = maxY;
    }

    fg.ondraw = function () {
        ctx.__novaFont.lineWidth = 20;
        ctx.__novaFont.widthLimit = 205;
        ctx.color = 0xffffffff;
        ctx.__novaFont.fill(info[selected], 530, 350);
        ctx.__novaFont.lineWidth = 0;
        ctx.__novaFont.widthLimit = -1;
    };

    fg.attach(list);
    fg.attach(scroll);
    fg.attach(addButton(scene, res.sheet1, 279, 648, 227, 70, [0, 400, 0, 0, 0, 71], function () { if (selected != 0) scene.startCustomMap(stage, rName, rMax); /*시작하기*/ }));
    fg.attach(addButton(scene, res.sheet1, 518, 648, 227, 70, [0, 400, 239, 0, 239, 71], function () { fg.remove();  /*나가기*/ }));
    fg.attach(modelview);

    this.fg = fg;

}

//\21\12 원래색
//\21\13 노란색
//\21\14 서브코어색
//\21\15 빨간색

var tuto = new MapList();
var arcade = new MapList();

tuto.addList("기본적인 조작",
 "\21\13기본적인 조작\n레벨 1 ~ 4 경험치 획득 가능\21\12\n\n"
+"노바1492는 시간이 지날수록 쌓이는 와트를 모아 유닛을 생산해서 상대의 기지를 파괴하면 승리하는 게임입니다. 게임의 기본을 익혀봅시다.\nShift를 누른 채 1 키를 눌러 1번째 칸에 조립한 유닛을 생산해보세요.\n1 키를 눌러 1번째 칸에 조립한 유닛을 모두 선택해보세요.\nAlt를 누른 채 1 키를 눌러 1번째 칸의 스킬을 사용해보세요.",
 3025, "tuto001", "전투 훈련 방", 1);

tuto.addList("집중 공격",
 "\21\13집중 공격\n레벨 5 ~ 8 경험치 획득 가능\21\12\n\n"
+ "유닛들을 선택하고 A키를 눌러 적 유닛을 선택하거나 마우스 우클릭으로 선택하면 선택된 유닛을 집중적으로 공격합니다. 상대의 핵심 유닛을 집중 공격으로 하나씩 제거하며 전투에서 승리하세요.",
 3022, "tuto002", "전투 훈련 방", 1);

tuto.addList("이동 사격",
 "\21\13이동 사격\n레벨 9 ~ 12 경험치 획득 가능\21\12\n\n"
+ "유닛들을 선택하고 S키를 눌러 손을 떼지 않은 채로 이동하고자 하는 지점을 마우스 우클릭으로 반복해서 클릭하면 사거리 안에 들어오는 상대 유닛들을 공격하며 자연스럽게 이동합니다. 이동 사격을 활용하면 자신보다 사거리가 짧고 속도가 느린 유닛을 상대할 때 피해를 입지 않고 승리할 수 있습니다.",
 3019, "tuto003", "전투 훈련 방", 1);

tuto.addList("고정 포격",
 "\21\13고정 포격\n레벨 13 ~ 17 경험치 획득 가능\21\12\n\n"
+ "일부 무기는 D키를 누르고 대상 지점을 선택하면 시야 밖을 공격합니다. 이러한 무기들은 시야가 없어도 상대의 유닛 및 기지에 피해를 입힐 수 있습니다. 시야 밖에 있는 상대 유닛들을 원거리에서 모두 파괴하세요.",
 3036, "tuto004", "전투 훈련 방", 1);

tuto.addList("진형 유지",
 "\21\13진형 유지\n레벨 18 ~ 21 경험치 획득 가능\21\12\n\n"
+ "유닛이 넓게 퍼트리고 그 상태를 유지하면서 이동하면 범위 공격을 하는 유닛으로부터 입는 피해를 줄일 수 있습니다. 넓게 퍼트린 유닛들을 선택하고 F키를 눌러 목표 지점을 선택하면 진형을 그대로 유지한 채 이동하게 됩니다. 범위 공격으로 입는 피해를 줄여서 전투에서 승리하세요.",
 3031, "tuto005", "전투 훈련 방", 1);

tuto.addList("산개",
 "\21\13산개\n레벨 22 ~ 25 경험치 획득 가능\21\12\n\n"
+ "범위 공격을 하는 유닛을 상대로 싸울 때 자신의 유닛을 넓게 퍼트려 피해를 감소시키는 것은 중요합니다. 최소 사거리가 있는 유닛들을 선택하고 C키를 눌러 유닛들이 뭉친 중앙을 선택하면 C키를 누른 지점을 기준으로 넓게 퍼지게 됩니다. 넓게 퍼진 상태에서 범위 공격을 하는 상대와 싸우면 승리할 수 있습니다.",
 3001, "tuto006", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 데미시즈",
 "\21\13무기 활용 : 데미시즈\n레벨 26 ~ 27 경험치 획득 가능\21\12\n\n"
+ "데미시즈는 빠른 연사속도로 범위 공격을 할 수 있는 화력 지원 무기입니다. 접근하는 다수의 적 유닛을 적절한 자리에 배치한 데미시즈의 범위 공격으로 파괴하고 전투에서 승리하세요. 여기서 사용되는 데미시즈N은 데미시즈와 비슷하지만 성능이 다른 무기입니다. 이름 뒤에 N이 붙은 부품은 기존의 부품과 다른 성능을 가지고 있지만, S나 G가 붙은 부품은 기존의 부품과 성능이 동일합니다.",
 3005, "tuto007", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 아모건",
 "\21\13무기 활용 : 아모건\n레벨 28 ~ 29 경험치 획득 가능\21\12\n\n"
+ "아모건은 와트가 굉장히 낮아 대량으로 생산해서 다양한 역할을 수행할 수 있습니다. 이렇게 대량으로 생산되는 유닛들은 좀비라고 불리며, 방어가 낮은 유닛을 상대로 매우 강력합니다.",
 3009, "tuto008", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 배럴",
 "\21\13무기 활용 : 배럴\n레벨 30 ~ 31 경험치 획득 가능\21\12\n\n"
+ "배럴은 가벼운 무게로 저렴하게 시야 확보용 유닛을 만들 수 있습니다. 시야 유닛을 활용해서 적의 움직임을 미리 확인하고, 적의 공격을 시야 유닛으로 막아내며 전투에서 승리하세요.",
 3007, "tuto009", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 머신건",
 "\21\13무기 활용 : 머신건\n레벨 32 ~ 33 경험치 획득 가능\21\12\n\n"
+ "머신건은 와트가 굉장히 낮아 대량으로 생산해서 다양한 역할을 수행할 수 있습니다. 다수의 머신건으로 좁은 입구를 봉쇄해서 자신의 주요 유닛을 지켜내고 모든 적을 파괴하세요.",
 3006, "tuto010", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 듀얼건",
 "\21\13무기 활용 : 듀얼건\n레벨 34 ~ 35 경험치 획득 가능\21\12\n\n"
+ "듀얼건은 무게가 가볍고 연사속도가 빨라 공중 유닛을 만들기 좋은 무기입니다. 공중 유닛은 대부분의 지상 유닛으로부터 70%의 피해만 받으며, 지상 유닛의 시야가 닿지 않는 언덕 위로 올라가서 지상 유닛으로부터 받는 피해를 더욱 줄일 수 있습니다.",
 3008, "tuto011", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 에너맥스",
 "\21\13무기 활용 : 에너맥스\n레벨 36 ~ 37 경험치 획득 가능\21\12\n\n"
+ "에너맥스는 C키를 누르면 와트 100을 소모하여 일정 범위의 아군 유닛 및 기지의 체력을 회복시킵니다. 에너맥스로 위급한 상태의 유닛을 회복시키거나 체력이 얼마 남지 않는 기지를 회복시키는 것은 아군에게 도움이 됩니다.",
 3012, "tuto012", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 시즈",
 "\21\13무기 활용 : 시즈\n레벨 38 ~ 39 경험치 획득 가능\21\12\n\n"
+ "시즈는 저렴한 와트와 넓은 범위를 가진 장거리포입니다. 빠른 속도와 넓은 범위를 가진 시즈로 치고 빠지는 전략을 사용해서 공격해오는 다수의 적 유닛들을 모두 파괴하세요.",
 3001, "tuto013", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 헤비배럴",
 "\21\13무기 활용 : 헤비배럴\n레벨 40 ~ 41 경험치 획득 가능\21\12\n\n"
+ "일부 무기는 기지에 더 많은 피해를 입히며 이러한 무기로 상대의 기지만을 빠르게 파괴하는 것은 테러라 불립니다. 테러 무기 중 하나인 헤비배럴로 빠르게 기지만을 파괴해서 승리하세요.",
 3002, "tuto014", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 클러스터",
 "\21\13무기 활용 : 클러스터\n레벨 42 ~ 43 경험치 획득 가능\21\12\n\n"
+ "클러스터는 기지에 큰 피해를 입히는 테러 무기일 뿐만 아니라 빠른 연사속도와 범위 공격을 갖춰 방어력이 낮은 다수의 유닛들을 상대로 강력합니다. 최대한 많은 적에게 피해를 입혀 전투에서 승리하세요.",
 3003, "tuto015", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 파워맥스",
 "\21\13무기 활용 : 파워맥스\n레벨 44 ~ 45 경험치 획득 가능\21\12\n\n"
+ "파워맥스는 C키를 누르면 와트 100을 소모하여 잠시 동안 일정 범위의 유닛들의 공격력을 10 증가시킵니다. 파워맥스의 능력은 공격 상승 스킬과 함께 중첩이 가능하므로 스킬을 사용하는 것 외에도 테러 유닛의 공격력을 더욱 상승시켜 기지를 빠르게 파괴할 수 있습니다.",
 3011, "tuto016", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 발칸",
 "\21\13무기 활용 : 발칸\n레벨 46 ~ 47 경험치 획득 가능\21\12\n\n"
+ "발칸은 빠른 연사속도와 적당한 사거리를 가진 화력 지원 무기입니다. 발칸을 적절한 위치에 배치하는 것으로 방어가 낮은 지상 및 공중 유닛에게 큰 피해를 입힐 수 있습니다. 프리즈 스킬과 발칸의 사거리를 활용해서 전투에서 승리하세요.",
 3004, "tuto017", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 쇼크웨이브",
 "\21\13무기 활용 : 쇼크웨이브\n레벨 48 ~ 49 경험치 획득 가능\21\12\n\n"
+ "공격 대상의 최대 체력의 2% 만큼 고정 피해를 추가로 입히는 쇼크웨이브는 가까운 거리의 적에게 큰 피해를 입힐 수 있습니다. 특히 최소사거리가 있는 유닛에게 가깝게 접근하면 최소사거리가 있는 유닛은 쇼크웨이브를 공격할 수 없게 됩니다.",
 3025, "tuto018", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 블레이즈",
 "\21\13무기 활용 : 블레이즈\n레벨 50 ~ 51 경험치 획득 가능\21\12\n\n"
+ "블레이즈는 효과적인 무기는 아니지만, C키를 눌러 일정 범위 내에 있는 유닛 및 기지에게 피해를 입히는 화염을 생성합니다. 움직이지 않는 기지를 상대로 블레이즈의 능력을 여러 번 사용해서 파괴하세요.",
 3010, "tuto019", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 핸드케넌",
 "\21\13무기 활용 : 핸드케넌\n레벨 52 ~ 53 경험치 획득 가능\21\12\n\n"
+ "핸드케넌은 가볍고 와트가 낮아 저렴하고 성능이 좋은 팔형 유닛을 만들 수 있습니다. 적당한 방어력을 갖춘 팔형 유닛은 일부 공격으로부터 입는 피해를 완전히 차단할 수 있습니다.",
 3015, "tuto020", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 레이저",
 "\21\13무기 활용 : 레이저\n레벨 54 ~ 55 경험치 획득 가능\21\12\n\n"
+ "레이저는 대부분의 유닛을 상대하기 충분한 공격력을 가진 무난한 성능의 무기입니다. 공중 유닛으로 최소 사거리가 있는 상대 유닛의 최소 사거리 안으로 진입해서 피해를 최소화하며 전투에서 승리하세요.",
 3019, "tuto021", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 팔랑스",
 "\21\13무기 활용 : 팔랑스\n레벨 56 ~ 57 경험치 획득 가능\21\12\n\n"
+ "팔랑스는 빠른 연사속도와 긴 사거리를 가진 화력 지원 무기입니다. 대부분의 화력 지원 무기보다 긴 사거리를 가진 팔랑스를 프리즈 스킬과 함께 사용하여 피해를 받지 않고 전투에서 승리하세요.",
 3013, "tuto022", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 스카이킬러",
 "\21\13무기 활용 : 스카이킬러\n레벨 58 ~ 59 경험치 획득 가능\21\12\n\n"
+ "스카이킬러는 방어력이 낮은 다수의 공중 유닛에게 효과적인 공중 공격 전용 무기입니다. 스카이킬러의 사거리와 넓은 공격 범위를 활용하면 대부분의 공중 유닛을 상대로 어렵지 않게 승리할 수 있습니다.",
 3031, "tuto023", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 메가배럴",
 "\21\13무기 활용 : 메가배럴\n레벨 60 ~ 61 경험치 획득 가능\21\12\n\n"
+ "메가배럴은 팔형의 특징인 적당한 방어력으로 공격을 버티며 기지를 파괴하는 테러 무기입니다. 방어 세크리파이 스킬로 적의 공격으로 인한 피해를 최소화하며 기지를 파괴하세요.",
 3016, "tuto024", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 캐니스터",
 "\21\13무기 활용 : 캐니스터\n레벨 62 ~ 63 경험치 획득 가능\21\12\n\n"
+ "캐니스터는 기지에 큰 피해를 입히는 테러 무기입니다. 캐니스터의 가벼운 무게를 이용해서 속도가 빠르고 공격력이 높은 테러 유닛을 만들 수 있습니다. 쫓아오는 적보다 빠르게 이동해서 기지를 파괴하세요.",
 3018, "tuto025", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 헤비시즈",
 "\21\13무기 활용 : 헤비시즈\n레벨 64 ~ 65 경험치 획득 가능\21\12\n\n"
+ "헤비시즈는 사거리가 길고 넓은 범위를 가진 장거리포입니다. 특히 무게가 가벼워 공중 유닛으로 만들기 좋습니다. 헤비시즈의 긴 사거리를 이용해서 먼 거리에서 공격하여 상대의 대공 유닛들을 제거하세요.",
 3014, "tuto026", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 사라만다",
 "\21\13무기 활용 : 사라만다\n레벨 66 ~ 67 경험치 획득 가능\21\12\n\n"
+ "사라만다는 무게가 가볍고 와트가 낮아 대량으로 생산할 수 있습니다. 다수의 유닛을 산개해서 범위 공격으로 입는 피해를 줄인 뒤 상대의 유닛을 집중 공격해서 하나씩 파괴하면 승리할 수 있습니다.",
 3026, "tuto027", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 스핏파이어",
 "\21\13무기 활용 : 스핏파이어\n레벨 68 ~ 69 경험치 획득 가능\21\12\n\n"
+ "공격 대상의 최대 체력의 5% 만큼 고정 피해를 추가로 입히는 스핏파이어는 따로 공격력을 올리지 않아도 대부분의 지상 유닛을 상대할 수 있습니다. 방어를 극대화시킨 스핏파이어에게 위협적인 적을 먼저 파괴하여 전투에서 승리하세요.",
 3032, "tuto028", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 프롤릭스",
 "\21\13무기 활용 : 프롤릭스\n레벨 70 ~ 71 경험치 획득 가능\21\12\n\n"
+ "프롤릭스는 낮은 와트와 충분한 사거리를 가져 상대의 방어력이 낮은 유닛을 원거리에서 파괴하기 좋습니다. 프롤릭스의 긴 사거리와 공중 유닛이 가지는 장점인 기동성과 시야를 활용하여 전투에서 승리하세요.",
 3017, "tuto029", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 바실리스크",
 "\21\13무기 활용 : 바실리스크\n레벨 72 ~ 73 경험치 획득 가능\21\12\n\n"
+ "바실리스크는 높은 공격력으로 상대의 유닛을 집중 공격해서 파괴하기 좋습니다. 바실리스크에 위협적인 상대 유닛을 먼저 제거해서 전투에서 승리하세요. 바실리스크를 매치에서 활용할 경우 저주 하프라이프 스킬과 함께 활용하면 상대의 핵심 유닛을 제거하기 좋습니다.",
 3022, "tuto030", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 이지스",
 "\21\13무기 활용 : 이지스\n레벨 74 ~ 75 경험치 획득 가능\21\12\n\n"
+ "이지스는 C키를 누르면 와트 150을 소모하여 좁은 지역에 방어를 20 증가시키는 방어막을 생성합니다. 이지스의 방어막으로 방어력이 낮은 유닛을 지켜내서 전투에서 승리하세요.",
 3028, "tuto031", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 리코일건",
 "\21\13무기 활용 : 리코일건\n레벨 76 경험치 획득 가능\21\12\n\n"
+ "리코일건은 팔형 무기 중에서도 지상 및 공중 유닛을 효과적으로 공격할 수 있는 무기입니다. 공중 유닛으로 만든 리코일건은 충분한 시야를 확보할 뿐만 아니라 상대의 공중 유닛을 파괴할 수 있습니다. 프리즈 스킬과 리코일건의 방어력을 활용해서 다양한 공중 유닛을 상대로 승리하세요.",
 3023, "tuto032", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 로켓티어",
 "\21\13무기 활용 : 로켓티어\n레벨 77 경험치 획득 가능\21\12\n\n"
+ "로켓티어는 단 하나의 유닛으로 기지에 큰 피해를 입힐 수 있는 테러 무기입니다. 로켓티어를 선택하고 M키를 눌러 상대 기지를 클릭한 뒤 로켓티어가 기지 위에 정지하면 D키를 눌러 상대 기지를 선택하세요. 공격 데블스피릿과 같은 스킬들을 함께 사용하면 더 빠르게 기지를 파괴할 수 있습니다.",
 3020, "tuto033", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 네메시즈",
 "\21\13무기 활용 : 네메시즈\n레벨 78 경험치 획득 가능\21\12\n\n"
+ "네메시즈는 긴 사거리와 높은 공격력을 가진 장거리포입니다. 네메시즈의 공격은 탄속이 느리고 스플래시 범위가 좁아 대부분의 유닛은 네메시즈의 공격을 피할 수 있지만, 속도가 느린 유닛이나 움직이지 않는 기지는 네메시즈의 공격 대상으로 적합합니다.",
 3021, "tuto034", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 호크아이",
 "\21\13무기 활용 : 호크아이\n레벨 79 경험치 획득 가능\21\12\n\n"
+ "호크아이는 C키를 누르면 와트 100을 소모하여 멀리 있는 지역의 시야를 얻을 수 있습니다. 낮은 와트를 가진 호크아이 유닛으로 최대한 적 유닛의 공격을 받아내서 전투에서 승리하세요.",
 3033, "tuto035", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 슈팅스타",
 "\21\13무기 활용 : 슈팅스타\n레벨 80 경험치 획득 가능\21\12\n\n"
+ "슈팅스타는 기지에 굉장히 큰 피해를 입히는 테러 무기입니다. 슈팅스타를 기지 트랜스 스킬로 적의 기지로 이동시키세요. 트랜스 스킬을 사용한 뒤 모든 공격 상승 스킬을 슈팅스타에 사용하면 순식간에 기지를 파괴할 수 있습니다. 테러 중에서도 기지 트랜스를 이용한 테러는 특히 강력합니다.",
 3027, "tuto036", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 바주카",
 "\21\13무기 활용 : 바주카\n레벨 81 경험치 획득 가능\21\12\n\n"
+ "바주카는 높은 공격력과 적당한 사거리를 가진 범위 공격 무기입니다. 사거리가 짧은 유닛을 상대로는 원거리에서, 최소 사거리가 있는 유닛을 상대로는 근거리에서 공격하여 모든 적을 무찌르세요.",
 3024, "tuto037", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 스콜피오",
 "\21\13무기 활용 : 스콜피오\n레벨 82 경험치 획득 가능\21\12\n\n"
+ "스콜피오는 높은 공격력으로 다수의 적을 공격하는 무기입니다. 빠른 속도를 이용한 치고 빠지는 전략을 사용해서 적 유닛이 접근하기 전에 하나씩 파괴하세요.",
 3034, "tuto038", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 서먼",
 "\21\13무기 활용 : 서먼\n레벨 83 경험치 획득 가능\21\12\n\n"
+ "서먼은 C키를 누르면 와트 400을 소모하여 멀리 있는 자신의 유닛들을 서먼으로 순간이동시키는 스킬을 가지고 있습니다. 이 스킬로 위험한 상황의 유닛을 순간이동시켜 구출하거나 상대에게 예상치 못한 공격을 할 수 있습니다. 서먼을 활용해서 적의 기지를 파괴하세요.",
 3030, "tuto039", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 선더볼트",
 "\21\13무기 활용 : 선더볼트\n레벨 84 경험치 획득 가능\21\12\n\n"
+ "선더볼트는 공격 대상 주변의 적까지 동시에 전기 충격을 가하는 무기입니다. 전투 훈련에서는 작동하지 않지만 다른 플레이어의 유닛에게 공격하면 유닛의 이동 및 공격을 잠깐 동안 정지시킵니다. 최대한 많은 적을 공격 범위에 포함시켜 전투에서 승리하세요.",
 3029, "tuto040", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 오닉스",
 "\21\13무기 활용 : 오닉스\n레벨 85 경험치 획득 가능\21\12\n\n"
+ "오닉스는 저렴한 와트와 뛰어난 화력을 갖춘 무기입니다. 어깨형 무기의 특성상 적의 공격을 받으면 오래 버티지 못하는 체력을 가졌지만, 유닛을 7초간 무적으로 만드는 공격 데블스피릿 스킬과 함께 활용하여 적은 비용으로 적의 핵심 유닛을 제거할 수 있습니다.",
 3035, "tuto041", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 해머쇼크",
 "\21\13무기 활용 : 해머쇼크\n레벨 86 경험치 획득 가능\21\12\n\n"
+ "해머쇼크는 사거리가 짧지만 빠른 연사속도와 높은 공격력을 가졌으며 해머쇼크와 해머쇼크N 둘 다 C키를 눌러 유용한 특수효과를 사용할 수 있습니다. 해머쇼크는 굉장히 높은 방어력을 가졌음에도 불구하고 일부 무기에는 피해를 입는데, 해머쇼크의 높은 방어력을 무시하는 유닛을 먼저 파괴하면 승리할 수 있습니다.",
 3039, "tuto042", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 아누아이",
 "\21\13무기 활용 : 아누아이\n레벨 87 경험치 획득 가능\21\12\n\n"
+ "상대의 방어 40을 무시하는 아누아이는 방어력이 높은 공중 유닛에게 확실한 피해를 입힐 수 있는 공중 공격 전용 무기입니다. 또한, 다리로 스타쉽과 포퍼스를 사용하는 유닛에게는 30%의 추가 피해를 입힙니다. 아누아이에 접근하는 방어력이 높은 공중 유닛으로부터 피해를 최소화하고 승리하세요.",
 3041, "tuto043", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 멀티샷건",
 "\21\13무기 활용 : 멀티샷건\n레벨 88 경험치 획득 가능\21\12\n\n"
+ "멀티샷건은 빠른 연사속도로 다수의 적을 동시에 공격할 수 있는 무기이며 방어력이 낮은 유닛을 상대로 특히 강력합니다. 최대한 많은 적에게 공격을 동시에 명중시켜 전투에서 승리하세요.",
 3038, "tuto044", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 스틱스",
 "\21\13무기 활용 : 스틱스\n레벨 89 경험치 획득 가능\21\12\n\n"
+ "스틱스는 굉장히 높은 공격력을 가지고 있어 대부분의 공중 유닛을 두세번의 공격으로 파괴할 수 있습니다. 스틱스로 상대 유닛을 하나씩 줄여나가며 전투에서 승리하세요. 스틱스를 매치에서 활용할 경우 저주 하프라이프 스킬과 함께 활용하면 상대의 핵심 유닛을 제거하기 좋습니다.",
 3037, "tuto045", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 버닝소울",
 "\21\13무기 활용 : 버닝소울\n레벨 90 경험치 획득 가능\21\12\n\n"
+ "버닝소울은 긴 사거리와 넓은 공격 범위를 갖춘 장거리포입니다. 고정 포격을 활용한 버닝소울의 치고 빠지기는 속도가 느린 유닛들에게 지속적으로 피해를 입힐 수 있습니다. 적이 버닝소울에 접근하여 공격하기 전에 많은 피해를 누적시켜서 승리하세요.",
 3036, "tuto046", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 데빌클로",
 "\21\13무기 활용 : 데빌클로\n레벨 91 경험치 획득 가능\21\12\n\n"
+ "상대의 방어 100을 무시하는 데빌클로는 방어가 높은 유닛에게 강력한 무기입니다. 충분히 빠른 속도와 사거리, 그리고 방어무시를 활용하여 방어력이 높은 근거리 유닛들과 싸워 승리하세요.",
 3046, "tuto047", "전투 훈련 방", 1);
 
tuto.addList("무기 활용 : 프리징소울",
 "\21\13무기 활용 : 프리징소울\n레벨 92 경험치 획득 가능\21\12\n\n"
+ "프리징소울은 공격받은 적을 3초간 이동이 불가능하게 만듭니다. 프리징소울로 적의 이동을 제한하고 사거리가 긴 무기를 사용하면 아무런 피해 없이 적을 일방적으로 공격할 수 있습니다.",
 3043, "tuto048", "전투 훈련 방", 1);
 
tuto.addList("무기 활용 : 스나이퍼",
 "\21\13무기 활용 : 스나이퍼\n레벨 93 경험치 획득 가능\21\12\n\n"
+ "스나이퍼는 굉장히 긴 사거리와 높은 공격력을 가진 저격 무기입니다. 최소 사거리가 굉장히 길어 익숙해지기까지 시간이 걸리지만 숙련될 경우 강력한 무기가 됩니다. 스나이퍼와 저주 하프라이프 스킬을 함께 사용해서 적 유닛들을 모두 파괴하세요.",
 3504, "tuto049", "전투 훈련 방", 1);
 
tuto.addList("무기 활용 : 에리니스",
 "\21\13무기 활용 : 에리니스\n레벨 94 경험치 획득 가능\21\12\n\n"
+ "에리니스는 적에게 입힌 피해의 30%만큼 자신의 체력을 회복합니다. 특히 방어 엔젤가드 스킬을 에리니스에 사용하면 다수의 적을 상대로도 오래 버틸 수 있습니다.",
 3501, "tuto050", "전투 훈련 방", 1);
  
tuto.addList("무기 활용 : 베베세",
 "\21\13무기 활용 : 베베세\n레벨 95 경험치 획득 가능\21\12\n\n"
+ "베베세는 빠른 연사와 넓은 범위를 가진 공중 공격 전용 무기입니다. 베베세는 와트가 비싸지만 한 기의 유닛으로도 수많은 공중 유닛들에게 치명적인 피해를 입힙니다.",
 3055, "tuto051", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 인센디어리",
 "\21\13무기 활용 : 인센디어리\n레벨 96 경험치 획득 가능\21\12\n\n"
+ "인센디어리는 공격한 지점에 1초마다 최대 체력의 5%만큼 피해를 입히는 화염을 3초간 생성합니다. C 키를 눌러서 지점을 선택하면 투사체 없이도 효과가 발동됩니다. 인센디어리의 효과를 활용해서 체력이 높은 적들을 파괴하세요.",
 3502, "tuto052", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 레디에이트",
 "\21\13무기 활용 : 레디에이트\n레벨 97 경험치 획득 가능\21\12\n\n"
+ "상대의 방어 50을 무시하는 레디에이트는 데빌클로보다 긴 사거리로 훨씬 먼 거리에서 방어력이 높은 유닛들을 제압합니다. 일직선상에 있는 모든 적에게 피해를 입히는 효과를 이용하면 훨씬 많은 피해를 입힐 수 있습니다.",
 3503, "tuto053", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 립타리온",
 "\21\13무기 활용 : 립타리온\n레벨 98 경험치 획득 가능\21\12\n\n"
+ "립타리온은 사거리가 길고 공격받은 적의 연사를 2초간 50 증가시키는 효과를 가진 무기입니다. 립타리온의 효과를 이용해서 연사가 낮은 스파이더 유닛들을 장거리에서 무력화시키세요.",
 3506, "tuto054", "전투 훈련 방", 1);

tuto.addList("무기 활용 : 아포칼립스",
 "\21\13무기 활용 : 아포칼립스\n레벨 99 경험치 획득 가능\21\12\n\n"
+ "아포칼립스는 굉장히 높은 공격력과 넓은 범위를 가진 장거리포입니다. 아포칼립스는 공격 이후 일정 시간동안 움직일 수 없고 연사가 1500이나 되지만 속도가 느린 유닛에게는 피할 수 없는 공격이 될 것입니다.",
 3505, "tuto055", "전투 훈련 방", 1);



arcade.addList("나만의 디펜스 만들기",
 "\21\13나만의 디펜스 만들기\n권장 인원 : 2명 ~ 8명\21\12\n\n"
+ "여러분만의 디펜스 게임을 만들어보세요. 방장은 자신의 덱에 있는 유닛을 공격자 인공지능에게 전달할 수 있습니다. 방장이 정한 시간 동안 인공지능이 보내는 유닛으로부터 기지를 방어하세요.",
 6061, "defencemaker", "나만의 디펜스 만들기", 8);

arcade.addList("나만의 블러드 만들기",
 "\21\13나만의 블러드 만들기\n권장 인원 : 2명 ~ 8명\21\12\n\n"
+ "여러분만의 블러드 게임을 만들어보세요. 방장의 1번 칸에 있는 유닛이 1초마다 모두에게 주어집니다. 기지가 파괴되거나 기지를 띄우면 탈락합니다. 생존 중인 인원이 많을수록 한 플레이어가 가질 수 있는 최대 유닛 수가 감소합니다.",
 6061, "bloodmaker", "나만의 블러드 만들기", 8);

arcade.addList("노바 대난투",
 "\21\13노바 대난투\n권장 인원 : 2명 ~ 12명\21\12\n\n"
+ "거대한 전투가 시작됩니다! 방 위쪽의 플레이어들과 방 아래쪽의 플레이어들이 두 팀으로 갈려 서로의 중앙기지를 파괴해야 합니다. 맵의 좌측 상단에서 유닛을 선택해서 전장에 뛰어드세요! 맵의 우측 하단에서 시간이 지날수록 쌓이는 와트로 업그레이드를 하세요!",
 6076, "arena", "노바 대난투", 12);

arcade.addList("인공지능 전쟁",
 "\21\13인공지능 전쟁\n권장 인원 : 2명 ~ 6명\21\12\n\n"
+ "인공지능에게 유닛을 전달하세요! 방 위쪽의 플레이어들과 방 아래쪽의 플레이어들이 두 팀으로 갈려 서로의 중앙기지를 파괴해야 합니다. 맵의 하단에서 인공지능에게 지급할 유닛을 선택하면 맵 상단에 해당 유닛을 생산하는 건물이 생성됩니다. 일정 시간마다 인공지능 유닛이 건물에서 생성되어 상대 기지를 공격합니다.",
 3023, "aiwar", "인공지능 전쟁", 6);

arcade.addList("기차 피하기",
 "\21\13기차 피하기\n권장 인원 : 2명 ~ 8명\21\12\n\n"
+ "방장을 제외한 플레이어는 방장이 움직이는 기차를 피해서 3분 동안 생존해야 합니다. 방에 6명 이상이 입장할 경우 방장과 그 아래의 플레이어 두 명이 기차가 됩니다.",
 1015, "train", "기차 피하기", 8);

arcade.addList("불닭 탁구",
 "\21\13불닭 탁구\n권장 인원 : 2명 ~ 4명\21\12\n\n"
+ "가장 처음으로 개발된 아케이드 모드입니다. 자신의 영역에 있는 쇼크웨이브를 파괴하면 상대의 영역으로 쇼크웨이브가 넘어갑니다. 서로에게 쇼크웨이브를 튕겨내며 모든 상대 유닛을 파괴하세요!",
 3025, "pingpong", "불닭 탁구", 4);

arcade.addList("해머 돌리기",
 "\21\13해머 돌리기\n권장 인원 : 2명 ~ 8명\21\12\n\n"
+ "큰 인기를 얻었던 이벤트인 해머 피하기를 본딴 아케이드 게임입니다. 무지막지한 공격력을 가진 해머쇼크가 맵을 돌아다닙니다. 최대 여덟 명의 플레이어 중에서 마지막까지 살아남는 사람이 되기 위해 길 막기와 해머쇼크 유인하기를 비롯한 온갖 방법을 사용해서 경쟁자를 제거하세요!",
 3039, "hammer", "해머 돌리기", 8);

arcade.addList("로봇 마라톤",
"\21\13로봇 마라톤\n권장 인원 : 2명 ~ 12명\21\12\n\n"
+ "3885년에 마침내 특이점이 온 마라톤을 경험해보세요. 방장은 트랙을 몇 바퀴 돌아야 게임이 끝나는지 정할 수 있습니다. 무작위로 선택되는 유닛들을 잘 활용하면 최종 우승자가 될 수 있습니다. 운도 좋아야겠지만요!",
1501, "marathon", "로봇 마라톤", 12);

arcade.addList("눈치보며 데스쏘기",
"\21\13눈치보며 데스쏘기\n권장 인원 : 2명 ~ 12명\21\12\n\n"
+ "이벤트 중 눈치보며 데스쏘기를 아케이드 모드에 추가했습니다. 일정 시간마다 사람이 가장 많은 구역에 적 스핏파이어가 생성됩니다. 적절한 타이밍에 데스를 사용해서 최후까지 살아남는 1인이 되세요!",
3032, "death", "눈치보며 데스쏘기", 12);

arcade.addList("무한 메탈존",
"\21\13무한 메탈존\n권장 인원 : 2명 ~ 8명\21\12\n\n"
+ "방의 위쪽과 아래쪽이 다른 팀으로 갈라지는 팀전입니다. 와트가 무한입니다. SP 제한은 1000입니다. 평소에 상상하던 모든 걸 여기서 즐겨보세요.",
6040, "supermetal", "무한 메탈존", 8);

arcade.addList("술래잡기",
    "\21\13술래잡기\n권장 인원 : 2명 ~ 12명\21\12\n\n"
+ "더 이상 인공지능 해머를 상대로 도망다니지 마세요. 참가자 중 랜덤으로 술래 한 명이 정해집니다. 방장이 정한 시간 동안 술래를 피해서 도망다니면 승리합니다. 자신이 술래인데 다른 사람을 잡았다면 그 사람이 새로운 술래가 됩니다.",
    3039, "chase", "술래잡기", 12);

/*
arcade.addList("노바 OX 퀴즈",
    "\21\13노바 OX 퀴즈\n권장 인원 : 2명 ~ 12명\21\12\n\n"
+ "온타임 이벤트를 통해 진행되었던 OX 퀴즈를 이제 아케이드에서 만나보세요. 노바1492 내의 다양한 분야에서 출제되는 OX 퀴즈 문제를 풀며 노바 지식을 겨룰 수 있습니다.",
    3501, "oxquiz", "노바 OX 퀴즈", 12);
*/

if (scene.isQuestLobby){
	loadBackground("questlobby.png");
    // addButton(scene, res.sheet1, 425, 289, 174, 190, [0, 150, 0, 150, 239, 150], function () { scene.openTraining(); /*전투 훈련 버튼*/ }); // 2020 reisen training button bug fix (remove training button on scenelobby.js)
}
addButton(scene, res.sheet2, 644, 607, 82, 29, [0, 0, 84, 0, 168, 0], function () { scene.attach(arcade.fg); /*아케이드 버튼*/ }); // 2019 reisen bshop blab 626 -> 607

scene.openTraining = function () {
    scene.attach(tuto.fg);
}

scene.onkeydown = function (key) {
    if (key == 27) {
        if (scene.isQuestLobby) {
            tuto.remove();
            arcade.remove();
        }
    }
}